<?php

namespace FM\Service;

use FM\Factory\Fm00030000TarefasRecorrentesFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;
use FM\Service\FuncionariosHierarqService;
use FM\Service\Fm00004000TarefasService;

class Fm00030000TarefasRecorrentesService
{

    protected $Fm00030000TarefasRecorrentesFactory;
    protected $Environment;
    protected $newCode;
    protected $FuncionariosHierarqService;
    protected $Fm00004000TarefasService;

    public function __construct(EntityManager $entityManager, Fm00030000TarefasRecorrentesFactory $Fm00030000TarefasRecorrentesFactory, FuncionariosHierarqService $FuncionariosHierarqService, Environment $Environment, NewCode $newCode, Fm00004000TarefasService $Fm00004000TarefasService)
    {
        $this->connection                           = $entityManager->getConnection();
        $this->Fm00030000TarefasRecorrentesFactory  = $Fm00030000TarefasRecorrentesFactory;
        $this->FuncionariosHierarqService           = $FuncionariosHierarqService;
        $this->Environment                          = $Environment;
        $this->newCode                              = $newCode;
        $this->Fm00004000TarefasService             = $Fm00004000TarefasService;
    }

    public function getTarefasRecorrentes()
    {
        $retorno = $this->Fm00030000TarefasRecorrentesFactory->getDadosTarefaRecorrente();
        $this->validaErroRecorrente($retorno);
        return $retorno;
    }

    public function validaErroRecorrente()
    {
        $this->connection->beginTransaction();
        try {
            $retorno =  $this->Fm00030000TarefasRecorrentesFactory->getErroRelatorio();
            foreach ($retorno as $validador) {
                if ($validador['VALIDA'] != null) {
                    $iderro = 'S';
                    $this->Fm00030000TarefasRecorrentesFactory->setIdErro($iderro, $validador['NRTAREFARECORRENTE']);
                } else {
                    $iderro = 'N';
                    $this->Fm00030000TarefasRecorrentesFactory->setIdErro($iderro, $validador['NRTAREFARECORRENTE']);
                }
            }
            $this->connection->commit();
        } catch (\Exception $e) {
            $this->connection->rollback();
            throw $e;
        }
    }

    public function getRelatoriosConflitos($filtro)
    {
        $filter = "";
        if ($filtro['NRTAREFARECORRENTE'] != 'S') {
            $filter = "WHERE NRTAREFARECORRENTE = " . $filtro['NRTAREFARECORRENTE'];
        }
        return $this->Fm00030000TarefasRecorrentesFactory->getRelatoriosConflitos($filter);
    }

    public function insertTarefasRecorrentes($param)
    {

        $this->connection->beginTransaction();
        try {
            $NRORG = $this->Environment->getNrOrg();
            $operador = $this->Environment->getCdOperador();
            if (!isset($param['RELATORIO']) || isset($param['RELATORIO']) && $param['RELATORIO'] != 'S') {
                foreach ($param['NRCRITERIOTAREFACHK'] as $key => $criterio) {
                    unset($param['NRCRITERIOTAREFACHK'][$key]['RNUM']);
                    unset($param['NRCRITERIOTAREFACHK'][$key]['TOTAL_LINES']);
                }
                if ($param['VISTORIA'] == '2') {
                    $param['VISTORIA'] = "N";
                } elseif ($param['VISTORIA'] == '1') {
                    $param['VISTORIA'] = "S";
                }
                    $nrTarefaRecorrente = $this->newCode->getCodeByTableName("FCM_TAREFARECORRENTE", $NRORG, 1, 10, true);
                    $parametro = array(
                        "NRTAREFARECORRENTE" => $nrTarefaRecorrente,
                        "NMTAREFA"           => $param['NOMETAREFA'],
                        "TPLOCALTAREFA"      => $param['NRTIPOLOCALCLI'],
                        "LOCALTAREFA"        => strval($param['NRLOCALCLIENTE']),
                        "NRCHECKLIST"        => $param['NRCHECKLIST'],
                        "ITENSCHECKLIST"     => implode(",", $param['NRATIVIDADECHK']),
                        "ESCOPOSTAREFA"      => implode(",", $param['NRESCOPOSTAREFA']),
                        "ITENSTAREFA"        => implode(",", $param['NRTAREFACHK']),
                        "CRITERIOS"          => json_encode($param['NRCRITERIOTAREFACHK']),
                        "DIASSEMANA"         => implode(",", $param['DIASEMANA']),
                        "HORARIO"            => $param['EXECUTORHORA'][0]['HORAINICIO'],
                        "DURACAO"            => $param['EXECUTORHORA'][0]['DURACAO'],
                        "IDCRIARVISTORIA"    => $param['VISTORIA'],
                        "NRORG"              => $NRORG,
                        "IDATIVO"            => "S",
                        "CDOPERINCLUSAO"     => $operador,
                        "NRORGINCLUSAO"      => $NRORG,
                        "IDSITUACAO"         => "1",
                        "CDOPERTAREFA"       => $param['EXECUTORHORA'][0]['FUNCIONARIO'],
                        "CDOPERVISTORIA"     => $param['EXECUTORHORA'][0]['ENCARREGADO'],
                        "CDCLIENTE"          => $param['CDCLIENTE'],
                        "NRSEQCONTRATO"      => isset($param['EXECUTORHORA'][0]['NRSEQCONTRATO']) ? $param['EXECUTORHORA'][0]['NRSEQCONTRATO'] : null,
                    );

                    $this->Fm00030000TarefasRecorrentesFactory->insertTarefasRecorrentes($parametro);

                    $params = $param;
                    $params['NRTAREFARECORRENTE'] = $nrTarefaRecorrente;
                    $params['VISTORIA'] = ($param['VISTORIA'] == "S") ? "1" : "2";
                    foreach ($params['EXECUTORHORA'] as $key => $executor) {
                        $params['EXECUTORHORA'][$key]["NRLOCALCLIENTE"] = $param['NRLOCALCLIENTE'];
                    }
                    $this->Fm00004000TarefasService->insertNovaTarefa($params);
            } else {
                $dadosTarefasRecorrentes = $this->Fm00030000TarefasRecorrentesFactory->pegarTodosDados(strval($param['NRTAREFARECORRENTE']));
                $parametros = array();
                $criaTarefa =  array(
                    "NRSEQCONTRATO"       => $param["NRSEQCONTRATO"],
                    "EXECUTORHORA"        => $param['EXECUTORHORA'],
                    "NRTAREFARECORRENTE"  => strval($dadosTarefasRecorrentes[0]['NRTAREFARECORRENTE']),
                    "NOMETAREFA"          => $dadosTarefasRecorrentes[0]['NMTAREFA'],
                    "NRTIPOLOCALCLI"      => explode(",", $dadosTarefasRecorrentes[0]['TPLOCALTAREFA']),
                    "NRLOCALCLIENTE"      => [array($dadosTarefasRecorrentes[0]['LOCALTAREFA'])[0]],
                    "NRCHECKLIST"         => $dadosTarefasRecorrentes[0]['NRCHECKLIST'],
                    "NRATIVIDADECHK"      => explode(",", $dadosTarefasRecorrentes[0]['ITENSCHECKLIST']),
                    "NRESCOPOSTAREFA"     => explode(",", $dadosTarefasRecorrentes[0]['ESCOPOSTAREFA']),
                    "NRTAREFACHK"         => explode(",", $dadosTarefasRecorrentes[0]['ITENSTAREFA']),
                    "NRCRITERIOTAREFACHK" => json_decode($dadosTarefasRecorrentes[0]['CRITERIOS'], true),
                    "DIASEMANA"           => explode(",", $dadosTarefasRecorrentes[0]['DIASSEMANA']),
                    "IDCRIARVISTORIA"     => $dadosTarefasRecorrentes[0]['IDCRIARVISTORIA'],
                    "NRORG"               => $dadosTarefasRecorrentes[0]['NRORG'],
                    "IDATIVO"             => "S",
                    "CDOPERINCLUSAO"      => $operador,
                    "NRORGINCLUSAO"       => $NRORG,
                    "IDSITUACAO"          => "1",
                    "DATERANGE"           => [date("m/d/Y"), date("m/t/Y")],
                    "OBSERVACOES"         => $dadosTarefasRecorrentes[0]['IDOBRIGAOBSERVACAO'],
                    "VISTORIA"            => ($dadosTarefasRecorrentes[0]['IDCRIARVISTORIA'] == 'S') ? '1' : '2',
                    "CDCLIENTE"           => $dadosTarefasRecorrentes[0]['CDCLIENTE'],

                );
                $tarefa = $criaTarefa;
                $tarefa['NRSEQCONTRATO'] = [$param['NRSEQCONTRATO']];

                $this->Fm00004000TarefasService->insertNovaTarefa($tarefa);
                foreach ($param['EDITROWS'] as $row) {
                    array_push(
                        $parametros,
                        $row['NRERROTAREFAREC']
                    );
                }
                $this->Fm00030000TarefasRecorrentesFactory->excluiRegistroRelatorio(implode(',', $parametros));
            }
            
            $this->connection->commit();
        } catch (\Exception $e) {
            $this->connection->rollback();
            throw $e;
        }
    }

    public function delRegistroRelatorio($parametro)
    {
        $param = implode(',', $parametro["NRS"]);
        $this->Fm00030000TarefasRecorrentesFactory->delRegistroRelatorio($param);
    }

    public function mudarStatusTarefaRecorrente($param)
    {
        
        $this->connection->beginTransaction();
        try {
            $paramDB = array(
                "NRTAREFARECORRENTE" => $param['NRTAREFARECORRENTE'],
                "IDSITUACAO" => null,
            );
            if ($param['TIPO'] == "PAUSAR") {
                $paramDB['IDSITUACAO'] = 2;
            } elseif ($param['TIPO'] == "INICIAR") {
                $paramDB['IDSITUACAO'] = 1;
            } elseif ($param['TIPO'] == "CANCELAR") {
                $paramDB['IDSITUACAO'] = 3;
            }
            
            $this->Fm00030000TarefasRecorrentesFactory->mudarStatusTarefaRecorrente($paramDB);

            switch ($paramDB['IDSITUACAO']) {
                case 1:
                    break;
                case 3:
                    $param["DATAFINAL"] = "";
                    // no break
                case 2:
                    $this->deletarPeriodoTarefaRecorrente($param);
                    if ($param["DATAFINAL"] != null) {
                        $this->dataRetorno($param);
                    }
                    break;
            }

            $this->connection->commit();
            $response = "OK";
        } catch (\Exception $e) {
            $this->connection->rollback();
            $response = "Erro";
        }
        return $response;
    }

    public function dataRetorno($param)
    {
        $dataReinicio = date("d/m/Y", strtotime($param["DATAFINAL"] . '+ 1 days'));
        $NR = $param["NRTAREFARECORRENTE"];

        $this->Fm00030000TarefasRecorrentesFactory->dataRetorno($dataReinicio, $NR);
    }

    public function inativarTarefasRecorrentes($parametros)
    {
        $this->connection->beginTransaction();
        try {
            $params = implode(',', $parametros["NRS"]);
            $filter = "";
            $filter .= "AND DTHORATAREFAAGEND >= TO_DATE('" . $parametros['DATAINICIO'] . "' ,'DD/MM/YYYY')";

            $this->Fm00030000TarefasRecorrentesFactory->deletarPeriodoTarefaRecorrente($params, $filter);

            $parametro = array(
                "NRTAREFARECORRENTE" => $params,
                "IDSITUACAO"         => '3',
            );
            $this->Fm00030000TarefasRecorrentesFactory->mudarStatusTarefaRecorrente($parametro);

            $this->connection->commit();
        } catch (\Exception $e) {
            $this->connection->rollback();
            throw $e;
        }
    }

    public function editarTarefaRecorrente($param)
    {
        $this->connection->beginTransaction();
        try {
            $params = array(
                "NRTAREFARECORRENTE"    => $param['NRTAREFARECORRENTE'],
                "DIASSEMANA"            => implode(",", $param['DIASSEMANA']),
                "HORARIO"               => $param['HORARIO'],
                "DURACAO"               => $param['DURACAO'],
                "CDOPERTAREFA"          => $param['CDOPERTAREFA'],
                "CDOPERVISTORIA"        => $param['CDOPERVISTORIA'],
                "CDOPERULTATU"          => $this->Environment->getCdOperador()
            );

            $this->Fm00030000TarefasRecorrentesFactory->editarTarefaRecorrente($params);
            $this->connection->commit();
        } catch (\Exception $e) {
            $this->connection->rollback();
            throw $e;
        }
    }

    public function deletarPeriodoTarefaRecorrente($param)
    {
       
        $dataFinal = date("d/m/Y", strtotime($param['DATAFINAL']));
        $filtrar = "";
        if (!$param['DATAFINAL'] || $dataFinal == null) {
            $filtrar .= "AND DTHORATAREFAAGEND >= TO_DATE('" . $param['DATAINICIAL'] . "' ,'DD/MM/YYYY')";
        } else {
            $filtrar .= "AND DTHORATAREFAAGEND BETWEEN TO_DATE('" . $param['DATAINICIAL'] . "' ,'DD/MM/YYYY') AND TO_DATE('" . $dataFinal . "','DD/MM/YYYY')";
        }
       
        $this->Fm00030000TarefasRecorrentesFactory->deletarPeriodoTarefaRecorrente($param["NRTAREFARECORRENTE"], $filtrar);
    }

    public function recriarTarefasRecorrentes($params)
    {
        $NRORG = $this->Environment->getNrOrg();
        $operador = $this->Environment->getCdOperador();
        $dadosTarefasRecorrentes = $this->Fm00030000TarefasRecorrentesFactory->pegarTodosDados(strval($params['NRTAREFARECORRENTE']));
        $dataInicial = (date("m/d/Y", strtotime($params['DATAINICIAL'])) < date("m/d/Y") ? date("m/d/Y") : $params['DATAINICIAL']);
        if (date("m/d/Y", strtotime($dataInicial)) < date("m/25/Y")) {
            $valida =   $this->Fm00030000TarefasRecorrentesFactory->validaPeriodo(strval($params['NRTAREFARECORRENTE']), date("d/m/Y", strtotime($dataInicial)));
            $NRSEQCONTRATO = [array("NRSEQCONTRATO" => intval($dadosTarefasRecorrentes[0]['NRSEQCONTRATO']))];
            $executorHora = $this->montaExecutorHora($dataInicial, date("m/t/Y"), $params['NRTAREFARECORRENTE'], $dadosTarefasRecorrentes[0]['LOCALTAREFA']);
            $criaTarefa =  array(
                "NRSEQCONTRATO"       => $NRSEQCONTRATO[0],
                "EXECUTORHORA"        => $executorHora,
                "NRTAREFARECORRENTE"  => strval($dadosTarefasRecorrentes[0]['NRTAREFARECORRENTE']),
                "NOMETAREFA"          => $dadosTarefasRecorrentes[0]['NMTAREFA'],
                "NRTIPOLOCALCLI"      => explode(",", $dadosTarefasRecorrentes[0]['TPLOCALTAREFA']),
                "NRLOCALCLIENTE"      => [array($dadosTarefasRecorrentes[0]['LOCALTAREFA'])[0]],
                "NRCHECKLIST"         => $dadosTarefasRecorrentes[0]['NRCHECKLIST'],
                "NRATIVIDADECHK"      => explode(",", $dadosTarefasRecorrentes[0]['ITENSCHECKLIST']),
                "NRESCOPOSTAREFA"     => explode(",", $dadosTarefasRecorrentes[0]['ESCOPOSTAREFA']),
                "NRTAREFACHK"         => explode(",", $dadosTarefasRecorrentes[0]['ITENSTAREFA']),
                "NRCRITERIOTAREFACHK" => json_decode($dadosTarefasRecorrentes[0]['CRITERIOS'], true),
                "DIASEMANA"           => explode(",", $dadosTarefasRecorrentes[0]['DIASSEMANA']),
                "IDCRIARVISTORIA"     => $dadosTarefasRecorrentes[0]['IDCRIARVISTORIA'],
                "NRORG"               => $NRORG,
                "IDATIVO"             => "S",
                "CDOPERINCLUSAO"      => $operador,
                "NRORGINCLUSAO"       => $NRORG,
                "IDSITUACAO"          => "1",
                "DATERANGE"           => [date("m/d/Y"), date("m/t/Y")],
                "OBSERVACOES"         => $dadosTarefasRecorrentes[0]['IDOBRIGAOBSERVACAO'],
                "VISTORIA"            => ($dadosTarefasRecorrentes[0]['IDCRIARVISTORIA'] == 'S') ? '1' : '2',
                "CDCLIENTE"           => $dadosTarefasRecorrentes[0]['CDCLIENTE'],

            );

            $this->Fm00004000TarefasService->insertNovaTarefa($criaTarefa);
        } elseif (date("m/d/Y", strtotime($dataInicial)) >= date("m/25/Y") && date("m/d/Y", strtotime($dataInicial)) < date("m/t/Y", strtotime(date("m/1/Y") . " +1month"))) {
            $dataFinal = date("m/t/Y", strtotime(date("m/1/Y") . " +1month"));
            $NRSEQCONTRATO = [array("NRSEQCONTRATO" => intval($dadosTarefasRecorrentes[0]['NRSEQCONTRATO']))];
            $executorHora = $this->montaExecutorHora($dataInicial, $dataFinal, $params['NRTAREFARECORRENTE'], $dadosTarefasRecorrentes[0]['LOCALTAREFA']);
            $criaTarefa =  array(
                "NRSEQCONTRATO"       => $NRSEQCONTRATO[0],
                "EXECUTORHORA"        => $executorHora,
                "NRTAREFARECORRENTE"  => strval($dadosTarefasRecorrentes[0]['NRTAREFARECORRENTE']),
                "NOMETAREFA"          => $dadosTarefasRecorrentes[0]['NMTAREFA'],
                "NRTIPOLOCALCLI"      => explode(",", $dadosTarefasRecorrentes[0]['TPLOCALTAREFA']),
                "NRLOCALCLIENTE"      => [array($dadosTarefasRecorrentes[0]['LOCALTAREFA'])[0]],
                "NRCHECKLIST"         => $dadosTarefasRecorrentes[0]['NRCHECKLIST'],
                "NRATIVIDADECHK"      => explode(",", $dadosTarefasRecorrentes[0]['ITENSCHECKLIST']),
                "NRESCOPOSTAREFA"     => explode(",", $dadosTarefasRecorrentes[0]['ESCOPOSTAREFA']),
                "NRTAREFACHK"         => explode(",", $dadosTarefasRecorrentes[0]['ITENSTAREFA']),
                "NRCRITERIOTAREFACHK" => json_decode($dadosTarefasRecorrentes[0]['CRITERIOS'], true),
                "DIASEMANA"           => explode(",", $dadosTarefasRecorrentes[0]['DIASSEMANA']),
                "IDCRIARVISTORIA"     => $dadosTarefasRecorrentes[0]['IDCRIARVISTORIA'],
                "NRORG"               => $NRORG,
                "IDATIVO"             => "S",
                "CDOPERINCLUSAO"      => $operador,
                "NRORGINCLUSAO"       => $NRORG,
                "IDSITUACAO"          => "1",
                "DATERANGE"           => [date("m/d/Y"), date("m/t/Y")],
                "OBSERVACOES"         => $dadosTarefasRecorrentes[0]['IDOBRIGAOBSERVACAO'],
                "VISTORIA"            => ($dadosTarefasRecorrentes[0]['IDCRIARVISTORIA'] == 'S') ? '1' : '2',
                "CDCLIENTE"           => $dadosTarefasRecorrentes[0]['CDCLIENTE'],

            );

            $this->Fm00004000TarefasService->insertNovaTarefa($criaTarefa);
        }

        $this->mudarStatusTarefaRecorrente(array(
            "TIPO"               => "INICIAR",
            "NRTAREFARECORRENTE" => $params["NRTAREFARECORRENTE"],
        ));

        $retiraReinicio = array(
            "NRTAREFARECORRENTE" =>  $params["NRTAREFARECORRENTE"],
            "DTHORAREINICIA" => "",
        );
        $this->Fm00030000TarefasRecorrentesFactory->retirarReinicio($retiraReinicio);
    }

    public function criaRecorrencia()
    {
        $NRS = $this->Fm00030000TarefasRecorrentesFactory->getTarefasRecorrente();
        $data = array(
            "DATAINICIAL" => date("m/1/Y", strtotime(date("m/1/Y") . " +1month")),
        );
        foreach ($NRS as $nr) {
            $this->recriarTarefasRecorrentes(array_merge($nr, $data));
        }
    }

    public function validaConflitos($dataInicio, $recorrente)
    {
        $tarefas = $this->Fm00030000TarefasRecorrentesFactory->getAllTasks();
        $duracao = (intdiv($recorrente[0]['DURACAO'], 100) * 60) + $recorrente[0]['DURACAO'] % 100;
        foreach ($tarefas as $tarefa) {
            $dig = strtotime(date("m/d/Y H:i", strtotime($tarefa['DTHORAAGEND'])));
            $dfg = strtotime(date("m/d/Y H:i", strtotime($tarefa['DTHRFINALAGEND'])));
            $din = strtotime(date("m/d/Y H:i", strtotime($dataInicio)));
            $dfn = strtotime(date("m/d/Y H:i", strtotime($dataInicio . ' +' . $duracao . 'minute')));

            if ($recorrente[0]['CDOPERTAREFA'] == $tarefa['CDOPERADOR']) {
                if (($din >= $dig && $din <= $dfg || $dfn >= $dig && $dfn <= $dfg) ||
                    $dig >= $din && $dig <= $dfn || $dig >= $din && $dig <= $dfn
                ) {
                    return true;
                }
            }
        }
    }

    public function montaExecutorHora($dataInicial, $dataFinal, $params, $nrlocalcliente)
    {
        $NRORG =  $this->Environment->getNrOrg();
        $operador = $this->Environment->getCdOperador();
        $executorHora = array();
        $relatorioConflito = array();
        $recorrente = $this->Fm00030000TarefasRecorrentesFactory->getDuracao($params);
        $duracao = (intdiv($recorrente[0]['DURACAO'], 100) * 60)  + $recorrente[0]['DURACAO'] % 100;
        for ($inicio = $dataInicial; $inicio <= $dataFinal; $inicio = (date("m/d/Y", strtotime($inicio . ' +1 day')))) {
            $inicio = $inicio . " " . $recorrente[0]['HORARIO'];
            if ($this->validaConflitos($inicio, $recorrente) != true) {
                array_push($executorHora, array(
                    "DATAINICIAL" => date("d/m/Y H:i", strtotime($inicio)),
                    "DATAFINAL"   => date("d/m/Y H:i", strtotime($inicio . ' +' . $duracao . ' minute')),
                    "DURACAO"     => $duracao,
                    "FUNCIONARIO" => $recorrente[0]['CDOPERTAREFA'],
                    "ENCARREGADO" => $recorrente[0]['CDOPERVISTORIA'],
                    "NRLOCALCLIENTE" => $nrlocalcliente
                ));
            } else {
                $NRERROTAREFAREC = $this->newCode->getCodeByTableName("FCM_ERROSTAREFAREC", $NRORG, 1, 10, true);
                array_push($relatorioConflito, array(
                    "DTINICIAL"        => date("d/m/Y H:i", strtotime($inicio)),
                    "DTFINAL"          => date("d/m/Y H:i", strtotime($inicio . ' +' . $duracao . ' minute')),
                    "DURACAO"            => $duracao,
                    "CDOPERRESPONSAVEL"  => $recorrente[0]['CDOPERTAREFA'],
                    "CDOPERENCARREGADO"  => $recorrente[0]['CDOPERVISTORIA'],
                    "NMTAREFARECORRENTE" => $recorrente[0]['NMTAREFA'],
                    "NRTAREFARECORRENTE" => $recorrente[0]['NRTAREFARECORRENTE'],
                    "NRERROTAREFAREC"    => $NRERROTAREFAREC,
                    "NRORG" => $NRORG,
                    "IDATIVO" => 'S',
                    "NRORGINCLUSAO" => $NRORG,
                    "NRLOCALCLIENTE" => $nrlocalcliente,
                ));
            }
        }
        foreach ($relatorioConflito as $conflito) {
            $this->Fm00030000TarefasRecorrentesFactory->criaRelatorio($conflito);
        }

        return $executorHora;
    }
}
