/* eslint-disable no-console */
/* eslint-disable */
import {
    IDictionary, Metadata, Http,
} from '@zeedhi/core';
import {
    Button, Form, Select, TextInput, LoadingService,
    Textarea,
    Text,
    Modal,
    ModalService,
    Tabs,
} from '@zeedhi/common';
import { getRoutePath } from '../../router';
import { ICardTitle, IterableComponentRender } from '@zeedhi/teknisa-components-common';
import { Utilities } from '@/util/Utilities';
import { TekIterableComponentRender } from '@zeedhi/teknisa-components-vuetify';


export class Fm00020000SolicitacoesController {
    public visibilidade: boolean = true;

    public NRGLOBAL: string = "";

    public NRCLASSIFY: string = "";

    public PARAMS: string = "";

    private classifyModal!: Modal;
    currentRow: any;

    /* -------------------- Tela: /solicitacoesDeTarefas -------------------- */
    get visibilidadeFrame() {
        return !this.visibilidade;
    }

    /* -------------------- Visibilidade e controle de frame/tabs/modal -------------------- */
    //Conrola visibilidade do frame
    public visualizarSolicitacoesDetalhes({ component }: any) {
        this.visibilidade = false;
        this.NRGLOBAL = String(component.name.split('_')[1]);
        this.recarregarTabs();
    }

    public voltarPagina() {
        this.visibilidade = true;
        Metadata.getInstance<Tabs>('tab-solicitacoes').activeTab = 0;
    }

    // Solicita uma nova requisição do datasource da tab Histórico
    public carregarHistorico() {
        try {
            if (Metadata.getInstance<Tabs>('tab-solicitacoes').activeTab == 0) {
                this.setFilterHistoric();
                Metadata.getInstance<IterableComponentRender>('requestTypesIterable').datasource.get();
            }
        } catch (error) { }
    }

    // Carregas as informações ao clicar na tab "Dados"
    public recarregarTabs() {
        const setOfTabs = Metadata.getInstance<Tabs>('tab-solicitacoes');

        if (setOfTabs.tabs[setOfTabs.activeTab].name === 'tab-solicitacoesDetalhes') {
            this.getRequestInfo();
        }
    }

    // Controle do modal Classificação 
    public async openClassifyModal({ component }: any) {
        this.NRCLASSIFY = String(component.name.split('_')[1]);
        this.classifyModal = await ModalService.createFromJson('/fm_00020_000_solicitacoes/modal/fm_00020_000_modal_classificar_solicitacoes', true);
        this.classifyModal.show();
    }

    // Fecha o modal de classificação.
    public closeClassifyModal() {
        this.classifyModal.hide();
        this.classifyModal.destroy();
    }

    // Muda o campo prioridade
    public setPriority({ component }: { component: Select }) {
        const priority = component.selectValue.IDPRIORIDADEPADR;
        const prioritySelect = Metadata.getInstance<Select>('classifyPriority');

        if (priority === 'Baixa') {
            prioritySelect.setValue('1');
        } else if (priority === 'Média') {
            prioritySelect.setValue('2');
        } else if (priority === 'Alta') {
            prioritySelect.setValue('3');
        } else {
            prioritySelect.setValue('4');
        }
    }

    /* ---------------------- Filtros --------------------*/

    public setFilterIteravel({ component }: any) {
        let id: any;

        switch (component.name) {
            case 'newRequestsIterable':
                id = "1";
                break;
            case 'requestsIPIterable':
                id = "2";
                break;
            case 'requestsMadeIterable':
                id = "3";

                break;
            case 'CompletedRequestsIterable':
                id = "4";
                break;
        }
        component.datasource.setFilter({
            IDSITUACAO: id
        });
    }

    public setFilterHistoric() {
        try {
            const tabComponent = Metadata.getInstance<TekIterableComponentRender>('requestTypesIterable');
            let filtroHistorico = this.NRGLOBAL;
            tabComponent.datasource.setFilter({
                NRSOLICITACAO: filtroHistorico
            });
        } catch (error) { }
    }
    /* -------------------- Controle botões e cards --------------------*/
    // Muda o label do botão "Ver descrição" na aba "Histórico"
    public changeDescriptionButton({ component }: { component: Button }) {
        const collapaseCard = component.parent as IDictionary;

        (component.label === 'Ver Descrição') ? (
            component.label = 'Fechar Descrição',
            collapaseCard.expanded = true
        ) : (
            component.label = 'Ver Descrição',
            collapaseCard.expanded = false
        );
    }

    // Título da página ( Usando assim porque será usada tb no modal)
    public requestTitle: string = '';

    public requestDescription: string = '';

    // Parametros usados para a classificação da solicitação (São usados assim pq tenho o modal sendo aberto por dois locais diferentes)
    public requestParams: IDictionary = {
        requestId: '',
        requestNrOpenedBy: '',
        requestOpenOn: '',
        requestNrLocation: '',
    }

    /* ------------------ Requisições para o banco -------------------- */
    // Busca a informação da solicitação específica e mostra nos campos
    public async getRequestInfo() {
        const id = this.NRGLOBAL;
        await Http.get(`/getRequestInfo?nrsolicitacao=${id}`).then((response: IDictionary) => {
            const database = response.data.dataset.info[0];
            const classifyButton = Metadata.getInstance<Button>('classifyButton');
            this.requestTitle = database.NMSOLICITACAO;
            this.requestDescription = database.DSSOLICITACAO;
            this.requestParams.requestId = database.NRSOLICITACAO;
            Metadata.getInstance<ICardTitle>('requestTitle').title = database.NMSOLICITACAO;
            Metadata.getInstance<Text>('requestOpenOn').text = database.DTSOLICITACAO;
            this.requestParams.requestOpenOn = database.DTSOLICITACAO;
            Metadata.getInstance<Text>('requestStatus').text = database.IDSITUACAO;
            Metadata.getInstance<Text>('requestLocation').text = database.NMLOCALCLIENTE;
            Metadata.getInstance<Text>('requestNrLocation').text = database.NRLOCALCLIENTE;
            this.requestParams.requestNrLocation = database.NRLOCALCLIENTE;
            Metadata.getInstance<Text>('requestType').text = database.NMTIPOSOLICITACAO;
            Metadata.getInstance<Text>('requestPriority').text = database.IDPRIORIDADE;
            Metadata.getInstance<Text>('requestOpenedBy').text = database.NMFUNCABERTURA;
            Metadata.getInstance<Text>('requestNrOpenedBy').text = database.CDOPERABERTURA;
            this.requestParams.requestNrOpenedBy = database.CDOPERABERTURA;
            Metadata.getInstance<Text>('taskResponsible').text = database.NMFUNCRESPONSAVEL;
            Metadata.getInstance<Text>('requestDescription').text = database.DSSOLICITACAO;

            if (database.IDSITUACAO != 'Pendente') {
                classifyButton.label = 'Classificado';
                classifyButton.disabled = true;
            } else {
                classifyButton.label = 'Classificar Solicitação';
                classifyButton.disabled = false;
            }
        });
    }

    // Quando aberto pela tela te solicitações ele faz a requisição e seta os valores
    public fillModal() {
        if (this.NRCLASSIFY == "undefined") {
            this.PARAMS = this.NRGLOBAL;
        } else {
            this.PARAMS = this.NRCLASSIFY;
        }
        const id = this.PARAMS;
        Http.get(`/getRequestInfo?nrsolicitacao=${id}`).then((response: IDictionary) => {
            const database = response.data.dataset.info[0];
            this.requestParams.requestId = database.NRSOLICITACAO;
            this.requestParams.requestNrOpenedBy = database.NRFUNCABERTURA;
            this.requestParams.requestOpenOn = database.DTSOLICITACAO;
            this.requestParams.requestNrLocation = database.NRLOCALCLIENTE;

            Metadata.getInstance<TextInput>('classifyTitle').value = database.NMSOLICITACAO;
            Metadata.getInstance<Textarea>('classifyDescription').value = database.DSSOLICITACAO;
        });
    }

    // Classificar solicitação
    public async classifyRequest() {
        if (Metadata.getInstance<Form>('classifyForm').validate()) {
            LoadingService.show();
           
            await Http.post('/classifyRequest', {
                NRSOLICITACAO: this.requestParams.requestId,
                NMSOLICITACAO: Metadata.getInstance<TextInput>('classifyTitle').value,
                NRTIPOSOLICITACAO: Metadata.getInstance<Select>('classifyType').value,
                IDPRIORIDADE: Metadata.getInstance<Select>('classifyPriority').value,
                CDOPERRESPONSAVEL: Metadata.getInstance<Select>('classifyResponsible').value,
                NRCHECKLIST: Metadata.getInstance<Select>('classifyChecklist').value,
                DSSOLICITACAO: Metadata.getInstance<Textarea>('classifyDescription').value,
                NRLOCALCLIENTE: this.requestParams.requestNrLocation,
                DTHISTSOLICITACAO: this.requestParams.requestOpenOn,
            }).then(() => {
                Utilities.showSuccessMessage();
                if (getRoutePath() === '/solicitacoesDeTarefas') {
                    //this.getRequests()
                } else {
                    // this.getRequestInfo();
                }
            }).catch((error: any) => {
                Utilities.showErrorMessage(error);
            }).finally(() => {
                this.closeClassifyModal();
                LoadingService.hide();
            });
        }
    }

    // Busca os tipos de requisição e monta o select
    public getRequestTypes() {
        const selectObject = Metadata.getInstance<Select>('classifyType');
        Http.get('/getRequestTypes').then((response: IDictionary) => {
            response.data.dataset.info.forEach((database: IDictionary) => {
                selectObject.datasource.data.push({
                    value: database.NRTIPOSOLICITACAO,
                    name: database.NMTIPOSOLICITACAO,
                    priority: database.IDPRIORIDADEPADR,
                });
            });
        });
    }
}
